Require Import bool.
Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import nat.
Parameter mod_aux : nat.nat -> nat.nat -> nat.nat -> nat.nat.
Parameter mod_aux_body : nat.nat -> nat.nat -> nat.nat -> nat.nat.
Axiom axiom_mod_aux : forall (p:nat.nat), connectives.equal (nat.nat -> nat.nat -> nat.nat) (mod_aux p) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) mod_aux_body p).
Definition eq_mod_aux : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (mod_aux p) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) mod_aux_body p) := fun (p:nat.nat) => ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (mod_aux p)) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) mod_aux_body p)) ((axiom_mod_aux) (p)).
Definition sym_eq_mod_aux : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) mod_aux_body p) (mod_aux p) := fun (p:nat.nat) => ((((leibniz.sym_leibniz) (nat.nat -> nat.nat -> nat.nat)) (mod_aux p)) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) mod_aux_body p)) ((eq_mod_aux) (p)).
Axiom axiom_mod_aux_body_O : connectives.equal (nat.nat -> nat.nat -> nat.nat) (mod_aux_body nat.O) (fun (m:nat.nat) => fun (n:nat.nat) => m).
Definition eq_mod_aux_body_O : leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (mod_aux_body nat.O) (fun (m:nat.nat) => fun (n:nat.nat) => m) := ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (mod_aux_body nat.O)) (fun (m:nat.nat) => fun (n:nat.nat) => m)) (axiom_mod_aux_body_O).
Definition sym_eq_mod_aux_body_O : leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (fun (m:nat.nat) => fun (n:nat.nat) => m) (mod_aux_body nat.O) := ((((leibniz.sym_leibniz) (nat.nat -> nat.nat -> nat.nat)) (mod_aux_body nat.O)) (fun (m:nat.nat) => fun (n:nat.nat) => m)) (eq_mod_aux_body_O).
Axiom axiom_mod_aux_body_S : forall (p:nat.nat), connectives.equal (nat.nat -> nat.nat -> nat.nat) (mod_aux_body (nat.S p)) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) m (mod_aux p (nat.minus m (nat.S n)) n) (nat.leb m n)).
Definition eq_mod_aux_body_S : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (mod_aux_body (nat.S p)) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) m (mod_aux p (nat.minus m (nat.S n)) n) (nat.leb m n)) := fun (p:nat.nat) => ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (mod_aux_body (nat.S p))) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) m (mod_aux p (nat.minus m (nat.S n)) n) (nat.leb m n))) ((axiom_mod_aux_body_S) (p)).
Definition sym_eq_mod_aux_body_S : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) m (mod_aux p (nat.minus m (nat.S n)) n) (nat.leb m n)) (mod_aux_body (nat.S p)) := fun (p:nat.nat) => ((((leibniz.sym_leibniz) (nat.nat -> nat.nat -> nat.nat)) (mod_aux_body (nat.S p))) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) m (mod_aux p (nat.minus m (nat.S n)) n) (nat.leb m n))) ((eq_mod_aux_body_S) (p)).
Definition mod : nat.nat -> nat.nat -> nat.nat := fun (n:nat.nat) => fun (m:nat.nat) => nat.match_nat_type (nat.nat) n (fun (p:nat.nat) => mod_aux n n p) m.
Definition le_mod_aux_m_m : forall (p:nat.nat), forall (n:nat.nat), forall (m:nat.nat), (nat.le n p) -> nat.le (mod_aux p n m) m := fun (p:nat.nat) => ((((nat.nat_ind) (fun (_x_365:nat.nat) => forall (n:nat.nat), forall (m:nat.nat), (nat.le n _x_365) -> nat.le (mod_aux _x_365 n m) m)) (fun (n:nat.nat) => fun (m:nat.nat) => (((sym_eq_mod_aux) (nat.O)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.le n nat.O) -> nat.le (y n m) m)) (((((nat.sym_eq_filter_nat_type_O) (nat.nat -> nat.nat -> nat.nat)) (mod_aux_body)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.le n nat.O) -> nat.le (y n m) m)) (((sym_eq_mod_aux_body_O) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.le n nat.O) -> nat.le (y n m) m)) (fun (lenO:nat.le n nat.O) => (((((nat.le_n_O_elim) (n)) (lenO)) (fun (__:nat.nat) => nat.le __ m)) ((nat.le_O_n) (m)))))))) (fun (q:nat.nat) => (((sym_eq_mod_aux) (nat.S q)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (forall (n:nat.nat), forall (m:nat.nat), (nat.le n q) -> nat.le (mod_aux q n m) m) -> forall (n:nat.nat), forall (m:nat.nat), (nat.le n (nat.S q)) -> nat.le (y n m) m)) ((((((nat.sym_eq_filter_nat_type_S) (nat.nat -> nat.nat -> nat.nat)) (mod_aux_body)) (q)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (forall (n:nat.nat), forall (m:nat.nat), (nat.le n q) -> nat.le (mod_aux q n m) m) -> forall (n:nat.nat), forall (m:nat.nat), (nat.le n (nat.S q)) -> nat.le (y n m) m)) ((((sym_eq_mod_aux_body_S) (q)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (forall (n:nat.nat), forall (m:nat.nat), (nat.le n q) -> nat.le (mod_aux q n m) m) -> forall (n:nat.nat), forall (m:nat.nat), (nat.le n (nat.S q)) -> nat.le (y n m) m)) (fun (Hind:forall (n:nat.nat), forall (m:nat.nat), (nat.le n q) -> nat.le (mod_aux q n m) m) => (fun (n:nat.nat) => fun (m:nat.nat) => fun (len:nat.le n (nat.S q)) => ((((((nat.leb_elim) (n)) (m)) (fun (__:bool.bool) => nat.le (bool.match_bool_type (nat.nat) n (mod_aux q (nat.minus n (nat.S m)) m) __) m)) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (n)) (mod_aux q (nat.minus n (nat.S m)) m)) (fun (y:nat.nat) => (nat.le n m) -> nat.le y m)) (fun (auto:nat.le n m) => (auto)))) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (n)) (mod_aux q (nat.minus n (nat.S m)) m)) (fun (y:nat.nat) => (connectives.Not (nat.le n m)) -> nat.le y m)) (fun (notlenm:connectives.Not (nat.le n m)) => ((((Hind) (nat.minus n (nat.S m))) (m)) (((((nat.le_plus_to_minus) (n)) (nat.S m)) (q)) ((((((nat.transitive_le) (n)) (nat.S q)) (nat.plus q (nat.S m))) (len)) (((((logic.eq_coerc) (nat.le (nat.S q) (nat.plus (nat.S q) m))) (nat.le (nat.S q) (nat.plus q (nat.S m)))) (((nat.le_plus_n_r) (m)) (nat.S q))) (((((((logic.rewrite_l) (nat.nat)) (nat.plus m (nat.S q))) (fun (__:nat.nat) => logic.eq (Prop) (nat.le (nat.S q) __) (nat.le (nat.S q) (nat.plus q (nat.S m))))) (((((((logic.rewrite_r) (nat.nat)) (nat.plus q (nat.S m))) (fun (__:nat.nat) => logic.eq (Prop) (nat.le (nat.S q) __) (nat.le (nat.S q) (nat.plus q (nat.S m))))) (((logic.refl) (Prop)) (nat.le (nat.S q) (nat.plus q (nat.S m))))) (nat.plus m (nat.S q))) (((((((logic.rewrite_l) (nat.nat)) (nat.S (nat.plus m q))) (fun (__:nat.nat) => logic.eq (nat.nat) __ (nat.plus q (nat.S m)))) (((((((logic.rewrite_l) (nat.nat)) (nat.plus q m)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.S __) (nat.plus q (nat.S m)))) (((nat.plus_n_Sm) (q)) (m))) (nat.plus m q)) (((nat.commutative_plus) (q)) (m)))) (nat.plus m (nat.S q))) (((nat.plus_n_Sm) (m)) (q))))) (nat.plus (nat.S q) m)) (((nat.commutative_plus) (m)) (nat.S q)))))))))))))))) (p).
Definition lt_mod_m_m : forall (n:nat.nat), forall (m:nat.nat), (nat.lt nat.O m) -> nat.lt (mod n m) m := fun (n:nat.nat) => fun (m:nat.nat) => ((((nat.match_nat_prop) (fun (__:nat.nat) => (nat.lt nat.O __) -> nat.lt (mod n __) __)) (fun (abs:nat.lt nat.O nat.O) => (((connectives.falsity) (nat.lt (mod n nat.O) nat.O)) ((((logic.absurd) (nat.le (nat.S nat.O) nat.O)) (abs)) ((nat.not_le_Sn_O) (nat.O)))))) (fun (p:nat.nat) => ((((((nat.sym_eq_match_nat_type_S) (nat.nat)) (n)) (fun (q:nat.nat) => mod_aux n n q)) (p)) (fun (y:nat.nat) => (nat.lt nat.O (nat.S p)) -> nat.lt y (nat.S p))) (fun (__:nat.lt nat.O (nat.S p)) => ((((nat.le_S_S) (mod_aux n n p)) (p)) (((((le_mod_aux_m_m) (n)) (n)) (p)) ((nat.le_n) (n))))))) (m).
